import { ScormResult } from './model/scorm-result';
import { Observable } from 'rxjs';
import { NgScormPlayerConfig } from './model/ng-scorm-player-config';
import { HttpClient } from '@angular/common/http';
export declare class NgScormPlayerService {
    private http;
    runtimeData: any;
    scormResult: ScormResult;
    closeWindowOnFinish: boolean;
    errorLogs: any;
    debug: boolean;
    urlLaunchPage: string;
    openInNewWindow: boolean;
    private initializeSource;
    initializeEvent: Observable<ScormResult>;
    private setValueSource;
    setValueEvent: Observable<ScormResult>;
    private getValueSource;
    getValueEvent: Observable<ScormResult>;
    private finishSource;
    finishEvent: Observable<ScormResult>;
    private commitSource;
    commitEvent: Observable<ScormResult>;
    constructor(config: NgScormPlayerConfig, http: HttpClient);
    /**
     * read the manifest and get the url launch page
     * @param urlDirSco url of the directory of the scorm
     */
    getUrlLaunchPage(urlDirSco: string): Observable<string>;
    Initialize(): boolean;
    SetValue(key: any, value: any): string;
    GetValue(key: any): string;
    Terminate(): boolean;
    Commit(): boolean;
    GetLastError(): any;
    GetErrorString(errorCode: any): string;
    GetDiagnostic(errorCode: any): string;
    LMSInitialize(): boolean;
    LMSFinish(data: any): boolean;
    LMSGetValue(key: string): string;
    LMSSetValue(key: any, value: string): string;
    LMSCommit(): boolean;
    LMSGetLastError(): any;
    LMSGetErrorString(errorCode: any): string;
    LMSGetDiagnostic(errorCode: any): string;
    MyInitialize(): boolean;
    MyFinish(): boolean;
    MyGetValue(key: string): string;
    MySetValue(key: any, value: string): string;
    MyCommit(): boolean;
    MyGetLastError(): any;
    MyGetErrorString(errorCode: any): string;
    MyGetDiagnostic(errocCode: any): string;
    private logErrorCode;
    private parseDurationString;
}
